]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
d5d61e4e81634092b1c4394774a902694e04447b
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 # Convenience
53 #
54 # A regexp to match 5 and 40 hexdigits
55 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
56 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
57
58 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
59 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86         -h|--h|--he|--hel|--help)
87                 help=t; shift ;;
88         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89                 verbose=t; shift ;;
90         -q|--q|--qu|--qui|--quie|--quiet)
91                 quiet=t; shift ;;
92         --with-dashes)
93                 with_dashes=t; shift ;;
94         --no-color)
95                 color=; shift ;;
96         --no-python)
97                 # noop now...
98                 shift ;;
99         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
100                 valgrind=t; verbose=t; shift ;;
101         --tee)
102                 shift ;; # was handled already
103         --root=*)
104                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
105                 shift ;;
106         *)
107                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
108         esac
109 done
110
111 if test -n "$color"; then
112         say_color () {
113                 (
114                 TERM=$ORIGINAL_TERM
115                 export TERM
116                 case "$1" in
117                         error) tput bold; tput setaf 1;; # bold red
118                         skip)  tput bold; tput setaf 2;; # bold green
119                         pass)  tput setaf 2;;            # green
120                         info)  tput setaf 3;;            # brown
121                         *) test -n "$quiet" && return;;
122                 esac
123                 shift
124                 printf " "
125                 printf "$@"
126                 tput sgr0
127                 )
128         }
129 else
130         say_color() {
131                 test -z "$1" && test -n "$quiet" && return
132                 shift
133                 printf " "
134                 printf "$@"
135         }
136 fi
137
138 error () {
139         say_color error "error: $*"
140         GIT_EXIT_OK=t
141         exit 1
142 }
143
144 say () {
145         say_color info "$*"
146 }
147
148 test "${test_description}" != "" ||
149 error "Test script did not set test_description."
150
151 if test "$help" = "t"
152 then
153         echo "Tests ${test_description}"
154         exit 0
155 fi
156
157 echo "Testing ${test_description}"
158
159 exec 5>&1
160 if test "$verbose" = "t"
161 then
162         exec 4>&2 3>&1
163 else
164         exec 4>/dev/null 3>/dev/null
165 fi
166
167 test_failure=0
168 test_count=0
169 test_fixed=0
170 test_broken=0
171 test_success=0
172
173 die () {
174         code=$?
175         if test -n "$GIT_EXIT_OK"
176         then
177                 exit $code
178         else
179                 echo >&5 "FATAL: Unexpected exit with code $code"
180                 exit 1
181         fi
182 }
183
184 GIT_EXIT_OK=
185 trap 'die' EXIT
186
187 test_decode_color () {
188         sed     -e 's/.\[1m/<WHITE>/g' \
189                 -e 's/.\[31m/<RED>/g' \
190                 -e 's/.\[32m/<GREEN>/g' \
191                 -e 's/.\[33m/<YELLOW>/g' \
192                 -e 's/.\[34m/<BLUE>/g' \
193                 -e 's/.\[35m/<MAGENTA>/g' \
194                 -e 's/.\[36m/<CYAN>/g' \
195                 -e 's/.\[m/<RESET>/g'
196 }
197
198 q_to_nul () {
199         perl -pe 'y/Q/\000/'
200 }
201
202 q_to_cr () {
203         tr Q '\015'
204 }
205
206 append_cr () {
207         sed -e 's/$/Q/' | tr Q '\015'
208 }
209
210 remove_cr () {
211         tr '\015' Q | sed -e 's/Q$//'
212 }
213
214 # Notmuch helper functions
215 increment_mtime_amount=0
216 increment_mtime ()
217 {
218     dir="$1"
219
220     increment_mtime_amount=$((increment_mtime_amount + 1))
221     touch -d "+${increment_mtime_amount} seconds" "$dir"
222 }
223
224 # Generate a new message in the mail directory, with a unique message
225 # ID and subject. The message is not added to the index.
226 #
227 # After this function returns, the filename of the generated message
228 # is available as $gen_msg_filename and the message ID is available as
229 # $gen_msg_id .
230 #
231 # This function supports named parameters with the bash syntax for
232 # assigning a value to an associative array ([name]=value). The
233 # supported parameters are:
234 #
235 #  [dir]=directory/of/choice
236 #
237 #       Generate the message in directory 'directory/of/choice' within
238 #       the mail store. The directory will be created if necessary.
239 #
240 #  [body]=text
241 #
242 #       Text to use as the body of the email message
243 #
244 #  '[from]="Some User <user@example.com>"'
245 #  '[to]="Some User <user@example.com>"'
246 #  '[subject]="Subject of email message"'
247 #  '[date]="RFC 822 Date"'
248 #
249 #       Values for email headers. If not provided, default values will
250 #       be generated instead.
251 #
252 #  '[cc]="Some User <user@example.com>"'
253 #  [reply-to]=some-address
254 #  [in-reply-to]=<message-id>
255 #  [references]=<message-id>
256 #  [content-type]=content-type-specification
257 #  '[header]=full header line, including keyword'
258 #
259 #       Additional values for email headers. If these are not provided
260 #       then the relevant headers will simply not appear in the
261 #       message.
262 #
263 #  '[id]=message-id'
264 #
265 #       Controls the message-id of the created message.
266 gen_msg_cnt=0
267 gen_msg_filename=""
268 gen_msg_id=""
269 generate_message ()
270 {
271     # This is our (bash-specific) magic for doing named parameters
272     local -A template="($@)"
273     local additional_headers
274
275     gen_msg_cnt=$((gen_msg_cnt + 1))
276     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
277
278     if [ -z "${template[id]}" ]; then
279         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
280     else
281         gen_msg_id="${template[id]}"
282     fi
283
284     if [ -z "${template[dir]}" ]; then
285         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
286     else
287         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
288         mkdir -p "$(dirname "$gen_msg_filename")"
289     fi
290
291     if [ -z "${template[body]}" ]; then
292         template[body]="This is just a test message (#${gen_msg_cnt})"
293     fi
294
295     if [ -z "${template[from]}" ]; then
296         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
297     fi
298
299     if [ -z "${template[to]}" ]; then
300         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301     fi
302
303     if [ -z "${template[subject]}" ]; then
304         template[subject]="Test message #${gen_msg_cnt}"
305     fi
306
307     if [ -z "${template[date]}" ]; then
308         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
309     fi
310
311     additional_headers=""
312     if [ ! -z "${template[header]}" ]; then
313         additional_headers="${template[header]}
314 ${additional_headers}"
315     fi
316
317     if [ ! -z "${template[reply-to]}" ]; then
318         additional_headers="Reply-To: ${template[reply-to]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[in-reply-to]}" ]; then
323         additional_headers="In-Reply-To: ${template[in-reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[cc]}" ]; then
328         additional_headers="Cc: ${template[cc]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[references]}" ]; then
333         additional_headers="References: ${template[references]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[content-type]}" ]; then
338         additional_headers="Content-Type: ${template[content-type]}
339 ${additional_headers}"
340     fi
341
342
343 cat <<EOF >"$gen_msg_filename"
344 From: ${template[from]}
345 To: ${template[to]}
346 Message-Id: <${gen_msg_id}>
347 Subject: ${template[subject]}
348 Date: ${template[date]}
349 ${additional_headers}
350 ${template[body]}
351 EOF
352
353     # Ensure that the mtime of the containing directory is updated
354     increment_mtime "$(dirname "${gen_msg_filename}")"
355 }
356
357 # Generate a new message and add it to the index.
358 #
359 # All of the arguments and return values supported by generate_message
360 # are also supported here, so see that function for details.
361 add_message ()
362 {
363     generate_message "$@" &&
364     notmuch new > /dev/null
365 }
366
367 test_begin_subtest ()
368 {
369     test_subtest_name="$1"
370 }
371
372 # Pass test if two arguments match
373 #
374 # Note: Unlike all other test_expect_* functions, this function does
375 # not accept a test name. Instead, the caller should call
376 # test_begin_subtest before calling this function in order to set the
377 # name.
378 test_expect_equal ()
379 {
380         test "$#" = 3 && { prereq=$1; shift; } || prereq=
381         test "$#" = 2 ||
382         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
383
384         output="$1"
385         expected="$2"
386         if ! test_skip "$@"
387         then
388                 say >&3 "expecting success: diff $output $expected"
389                 if [ "$output" = "$expected" ]; then
390                         test_ok_ "$test_subtest_name"
391                 else
392                         testname=$this_test.$test_count
393                         echo "$expected" > $testname.expected
394                         echo "$output" > $testname.output
395                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
396                 fi
397                 echo >&3 ""
398     fi
399 }
400
401 TEST_DIR=$(pwd)/test.$$
402 MAIL_DIR=${TEST_DIR}/mail
403 export NOTMUCH_CONFIG=${TEST_DIR}/notmuch-config
404 NOTMUCH=notmuch
405
406 NOTMUCH_NEW ()
407 {
408     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
409 }
410
411 notmuch_search_sanitize ()
412 {
413     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
414 }
415
416 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
417 notmuch_show_sanitize ()
418 {
419     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
420 }
421
422 # End of notmuch helper functions
423
424 # Use test_set_prereq to tell that a particular prerequisite is available.
425 # The prerequisite can later be checked for in two ways:
426 #
427 # - Explicitly using test_have_prereq.
428 #
429 # - Implicitly by specifying the prerequisite tag in the calls to
430 #   test_expect_{success,failure,code}.
431 #
432 # The single parameter is the prerequisite tag (a simple word, in all
433 # capital letters by convention).
434
435 test_set_prereq () {
436         satisfied="$satisfied$1 "
437 }
438 satisfied=" "
439
440 test_have_prereq () {
441         case $satisfied in
442         *" $1 "*)
443                 : yes, have it ;;
444         *)
445                 ! : nope ;;
446         esac
447 }
448
449 # You are not expected to call test_ok_ and test_failure_ directly, use
450 # the text_expect_* functions instead.
451
452 test_ok_ () {
453         test_success=$(($test_success + 1))
454         say_color pass "%-6s" "PASS"
455         echo " $@"
456 }
457
458 test_failure_ () {
459         test_failure=$(($test_failure + 1))
460         say_color error "%-6s" "FAIL"
461         echo " $1"
462         shift
463         echo "$@" | sed -e 's/^/        /'
464         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
465 }
466
467 test_known_broken_ok_ () {
468         test_fixed=$(($test_fixed+1))
469         say_color pass "%-6s" "FIXED"
470         echo " $@"
471 }
472
473 test_known_broken_failure_ () {
474         test_broken=$(($test_broken+1))
475         say_color pass "%-6s" "BROKEN"
476         echo " $@"
477 }
478
479 test_debug () {
480         test "$debug" = "" || eval "$1"
481 }
482
483 test_run_ () {
484         test_cleanup=:
485         eval >&3 2>&4 "$1"
486         eval_ret=$?
487         eval >&3 2>&4 "$test_cleanup"
488         return 0
489 }
490
491 test_skip () {
492         test_count=$(($test_count+1))
493         to_skip=
494         for skp in $NOTMUCH_SKIP_TESTS
495         do
496                 case $this_test.$test_count in
497                 $skp)
498                         to_skip=t
499                 esac
500         done
501         if test -z "$to_skip" && test -n "$prereq" &&
502            ! test_have_prereq "$prereq"
503         then
504                 to_skip=t
505         fi
506         case "$to_skip" in
507         t)
508                 say_color skip >&3 "skipping test: $@"
509                 say_color skip "%-6s" "SKIP"
510                 echo " $1"
511                 : true
512                 ;;
513         *)
514                 false
515                 ;;
516         esac
517 }
518
519 test_expect_failure () {
520         test "$#" = 3 && { prereq=$1; shift; } || prereq=
521         test "$#" = 2 ||
522         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
523         if ! test_skip "$@"
524         then
525                 say >&3 "checking known breakage: $2"
526                 test_run_ "$2"
527                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
528                 then
529                         test_known_broken_ok_ "$1"
530                 else
531                         test_known_broken_failure_ "$1"
532                 fi
533         fi
534         echo >&3 ""
535 }
536
537 test_expect_success () {
538         test "$#" = 3 && { prereq=$1; shift; } || prereq=
539         test "$#" = 2 ||
540         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
541         if ! test_skip "$@"
542         then
543                 say >&3 "expecting success: $2"
544                 test_run_ "$2"
545                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
546                 then
547                         test_ok_ "$1"
548                 else
549                         test_failure_ "$@"
550                 fi
551         fi
552         echo >&3 ""
553 }
554
555 test_expect_code () {
556         test "$#" = 4 && { prereq=$1; shift; } || prereq=
557         test "$#" = 3 ||
558         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
559         if ! test_skip "$@"
560         then
561                 say >&3 "expecting exit code $1: $3"
562                 test_run_ "$3"
563                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
564                 then
565                         test_ok_ "$2"
566                 else
567                         test_failure_ "$@"
568                 fi
569         fi
570         echo >&3 ""
571 }
572
573 # test_external runs external test scripts that provide continuous
574 # test output about their progress, and succeeds/fails on
575 # zero/non-zero exit code.  It outputs the test output on stdout even
576 # in non-verbose mode, and announces the external script with "* run
577 # <n>: ..." before running it.  When providing relative paths, keep in
578 # mind that all scripts run in "trash directory".
579 # Usage: test_external description command arguments...
580 # Example: test_external 'Perl API' perl ../path/to/test.pl
581 test_external () {
582         test "$#" = 4 && { prereq=$1; shift; } || prereq=
583         test "$#" = 3 ||
584         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
585         descr="$1"
586         shift
587         if ! test_skip "$descr" "$@"
588         then
589                 # Announce the script to reduce confusion about the
590                 # test output that follows.
591                 say_color "" " run $test_count: $descr ($*)"
592                 # Run command; redirect its stderr to &4 as in
593                 # test_run_, but keep its stdout on our stdout even in
594                 # non-verbose mode.
595                 "$@" 2>&4
596                 if [ "$?" = 0 ]
597                 then
598                         test_ok_ "$descr"
599                 else
600                         test_failure_ "$descr" "$@"
601                 fi
602         fi
603 }
604
605 # Like test_external, but in addition tests that the command generated
606 # no output on stderr.
607 test_external_without_stderr () {
608         # The temporary file has no (and must have no) security
609         # implications.
610         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
611         stderr="$tmp/git-external-stderr.$$.tmp"
612         test_external "$@" 4> "$stderr"
613         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
614         descr="no stderr: $1"
615         shift
616         say >&3 "expecting no stderr from previous command"
617         if [ ! -s "$stderr" ]; then
618                 rm "$stderr"
619                 test_ok_ "$descr"
620         else
621                 if [ "$verbose" = t ]; then
622                         output=`echo; echo Stderr is:; cat "$stderr"`
623                 else
624                         output=
625                 fi
626                 # rm first in case test_failure exits.
627                 rm "$stderr"
628                 test_failure_ "$descr" "$@" "$output"
629         fi
630 }
631
632 # This is not among top-level (test_expect_success | test_expect_failure)
633 # but is a prefix that can be used in the test script, like:
634 #
635 #       test_expect_success 'complain and die' '
636 #           do something &&
637 #           do something else &&
638 #           test_must_fail git checkout ../outerspace
639 #       '
640 #
641 # Writing this as "! git checkout ../outerspace" is wrong, because
642 # the failure could be due to a segv.  We want a controlled failure.
643
644 test_must_fail () {
645         "$@"
646         test $? -gt 0 -a $? -le 129 -o $? -gt 192
647 }
648
649 # test_cmp is a helper function to compare actual and expected output.
650 # You can use it like:
651 #
652 #       test_expect_success 'foo works' '
653 #               echo expected >expected &&
654 #               foo >actual &&
655 #               test_cmp expected actual
656 #       '
657 #
658 # This could be written as either "cmp" or "diff -u", but:
659 # - cmp's output is not nearly as easy to read as diff -u
660 # - not all diff versions understand "-u"
661
662 test_cmp() {
663         $GIT_TEST_CMP "$@"
664 }
665
666 # This function can be used to schedule some commands to be run
667 # unconditionally at the end of the test to restore sanity:
668 #
669 #       test_expect_success 'test core.capslock' '
670 #               git config core.capslock true &&
671 #               test_when_finished "git config --unset core.capslock" &&
672 #               hello world
673 #       '
674 #
675 # That would be roughly equivalent to
676 #
677 #       test_expect_success 'test core.capslock' '
678 #               git config core.capslock true &&
679 #               hello world
680 #               git config --unset core.capslock
681 #       '
682 #
683 # except that the greeting and config --unset must both succeed for
684 # the test to pass.
685
686 test_when_finished () {
687         test_cleanup="{ $*
688                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
689 }
690
691 test_done () {
692         GIT_EXIT_OK=t
693         test_results_dir="$TEST_DIRECTORY/test-results"
694         mkdir -p "$test_results_dir"
695         test_results_path="$test_results_dir/${0%.sh}-$$"
696
697         echo "total $test_count" >> $test_results_path
698         echo "success $test_success" >> $test_results_path
699         echo "fixed $test_fixed" >> $test_results_path
700         echo "broken $test_broken" >> $test_results_path
701         echo "failed $test_failure" >> $test_results_path
702         echo "" >> $test_results_path
703
704         echo
705
706         if [ "$test_failure" = "0" ]; then
707             rm -rf "$remove_tmp"
708             exit 0
709         else
710             exit 1
711         fi
712 }
713
714 find_notmuch_path ()
715 {
716     dir="$1"
717
718     while [ -n "$dir" ]; do
719         bin="$dir/notmuch"
720         if [ -x "$bin" ]; then
721             echo "$dir"
722             return
723         fi
724         dir="$(dirname "$dir")"
725         if [ "$dir" = "/" ]; then
726             break
727         fi
728     done
729 }
730
731 # Test the binaries we have just built.  The tests are kept in
732 # test/ subdirectory and are run in 'trash directory' subdirectory.
733 TEST_DIRECTORY=$(pwd)
734 if test -n "$valgrind"
735 then
736         make_symlink () {
737                 test -h "$2" &&
738                 test "$1" = "$(readlink "$2")" || {
739                         # be super paranoid
740                         if mkdir "$2".lock
741                         then
742                                 rm -f "$2" &&
743                                 ln -s "$1" "$2" &&
744                                 rm -r "$2".lock
745                         else
746                                 while test -d "$2".lock
747                                 do
748                                         say "Waiting for lock on $2."
749                                         sleep 1
750                                 done
751                         fi
752                 }
753         }
754
755         make_valgrind_symlink () {
756                 # handle only executables
757                 test -x "$1" || return
758
759                 base=$(basename "$1")
760                 symlink_target=$TEST_DIRECTORY/../$base
761                 # do not override scripts
762                 if test -x "$symlink_target" &&
763                     test ! -d "$symlink_target" &&
764                     test "#!" != "$(head -c 2 < "$symlink_target")"
765                 then
766                         symlink_target=../valgrind.sh
767                 fi
768                 case "$base" in
769                 *.sh|*.perl)
770                         symlink_target=../unprocessed-script
771                 esac
772                 # create the link, or replace it if it is out of date
773                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
774         }
775
776         # override notmuch executable in TEST_DIRECTORY/..
777         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
778         mkdir -p "$GIT_VALGRIND"/bin
779         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
780         OLDIFS=$IFS
781         IFS=:
782         for path in $PATH
783         do
784                 ls "$path"/notmuch 2> /dev/null |
785                 while read file
786                 do
787                         make_valgrind_symlink "$file"
788                 done
789         done
790         IFS=$OLDIFS
791         PATH=$GIT_VALGRIND/bin:$PATH
792         GIT_EXEC_PATH=$GIT_VALGRIND/bin
793         export GIT_VALGRIND
794 else # normal case
795         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
796         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
797 fi
798 export PATH
799
800 # Test repository
801 test="tmp.$(basename "$0" .sh)"
802 test -n "$root" && test="$root/$test"
803 case "$test" in
804 /*) TMP_DIRECTORY="$test" ;;
805  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
806 esac
807 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
808 rm -fr "$test" || {
809         GIT_EXIT_OK=t
810         echo >&5 "FATAL: Cannot prepare test area"
811         exit 1
812 }
813
814 MAIL_DIR="${TMP_DIRECTORY}/mail"
815 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
816
817 mkdir -p "${test}"
818 mkdir "$MAIL_DIR"
819
820 cat <<EOF >"${NOTMUCH_CONFIG}"
821 [database]
822 path=${MAIL_DIR}
823
824 [user]
825 name=Notmuch Test Suite
826 primary_email=test_suite@notmuchmail.org
827 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
828 EOF
829
830
831 # Use -P to resolve symlinks in our working directory so that the cwd
832 # in subprocesses like git equals our $PWD (for pathname comparisons).
833 cd -P "$test" || error "Cannot setup test environment"
834
835 this_test=${0##*/}
836 this_test=${this_test%%-*}
837 for skp in $NOTMUCH_SKIP_TESTS
838 do
839         to_skip=
840         for skp in $NOTMUCH_SKIP_TESTS
841         do
842                 case "$this_test" in
843                 $skp)
844                         to_skip=t
845                 esac
846         done
847         case "$to_skip" in
848         t)
849                 say_color skip >&3 "skipping test $this_test altogether"
850                 say_color skip "skip all tests in $this_test"
851                 test_done
852         esac
853 done
854
855 # Provide an implementation of the 'yes' utility
856 yes () {
857         if test $# = 0
858         then
859                 y=y
860         else
861                 y="$*"
862         fi
863
864         while echo "$y"
865         do
866                 :
867         done
868 }
869
870 # Fix some commands on Windows
871 case $(uname -s) in
872 *MINGW*)
873         # Windows has its own (incompatible) sort and find
874         sort () {
875                 /usr/bin/sort "$@"
876         }
877         find () {
878                 /usr/bin/find "$@"
879         }
880         sum () {
881                 md5sum "$@"
882         }
883         # git sees Windows-style pwd
884         pwd () {
885                 builtin pwd -W
886         }
887         # no POSIX permissions
888         # backslashes in pathspec are converted to '/'
889         # exec does not inherit the PID
890         ;;
891 *)
892         test_set_prereq POSIXPERM
893         test_set_prereq BSLASHPSPEC
894         test_set_prereq EXECKEEPSPID
895         ;;
896 esac
897
898 test -z "$NO_PERL" && test_set_prereq PERL
899 test -z "$NO_PYTHON" && test_set_prereq PYTHON
900
901 # test whether the filesystem supports symbolic links
902 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
903 rm -f y